/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.58 Revision 1.89
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.58 2007/01/04 20:38:16 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.89 2008/04/05 00:43:26 robbat2 Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
7 4
8# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
9# Maintainer: Luca Longinotti <chtekk@gentoo.org> 7# - Luca Longinotti <chtekk@gentoo.org>
8# - Robin H. Johnson <robbat2@gentoo.org>
10 9
11# Note that MYSQL_VERSION_ID must be empty !!! 10WANT_AUTOCONF="latest"
11WANT_AUTOMAKE="latest"
12 12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15inherit eutils flag-o-matic gnuconfig autotools mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx
16 14
17# avoid running userspace code 8 times per ebuild :( 15# Shorten the path because the socket path length must be shorter than 107 chars
18if [[ "${_MYPVR}" != "${PVR}" ]] && [[ -n "${PVR}" ]] 16# and we will run a mysql server during test phase
19then 17S="${WORKDIR}/mysql"
20 _MYPVR=${PVR}
21 18
22 [[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070104" 19[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108"
20if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
21 EGIT_PROJECT=mysql-extras
22 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
23 inherit git
24fi
23 25
24 if [[ ${PR#r} -lt 60 ]] ; then 26if [[ ${PR#r} -lt 60 ]] ; then
25 IS_BITKEEPER=0 27 IS_BITKEEPER=0
26 elif [[ ${PR#r} -lt 90 ]] ; then 28elif [[ ${PR#r} -lt 90 ]] ; then
27 IS_BITKEEPER=60 29 IS_BITKEEPER=60
28 else 30else
29 IS_BITKEEPER=90 31 IS_BITKEEPER=90
30 fi 32fi
31 33
32 # MYSQL_VERSION_ID will be: 34# MYSQL_VERSION_ID will be:
33 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 35# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
34 # This is an important part, because many of the choices the MySQL ebuild will do 36# This is an important part, because many of the choices the MySQL ebuild will do
35 # depend on this variable. 37# depend on this variable.
36 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 38# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
39# We also strip off upstream's trailing letter that they use to respin tarballs
40
37 MYSQL_VERSION_ID="" 41MYSQL_VERSION_ID=""
42tpv="${PV%[a-z]}"
38 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 43tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
39 for vatom in 0 1 2 3 ; do 44for vatom in 0 1 2 3 ; do
40 # pad to length 2 45 # pad to length 2
41 tpv[${vatom}]="00${tpv[${vatom}]}" 46 tpv[${vatom}]="00${tpv[${vatom}]}"
42 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 47 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
43 done 48done
44 # strip leading "0" (otherwise it's considered an octal number by BASH) 49# strip leading "0" (otherwise it's considered an octal number by BASH)
45 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 50MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
46 51
47 # Be warned, *DEPEND are version-dependant 52# Be warned, *DEPEND are version-dependant
48 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 53DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
49 userland_GNU? ( sys-process/procps ) 54 userland_GNU? ( sys-process/procps )
50 >=sys-apps/sed-4 55 >=sys-apps/sed-4
51 >=sys-apps/texinfo-4.7-r1 56 >=sys-apps/texinfo-4.7-r1
52 >=sys-libs/readline-4.1 57 >=sys-libs/readline-4.1
53 >=sys-libs/zlib-1.2.3 58 >=sys-libs/zlib-1.2.3"
54 "
55 59
56 # having different flavours at the same time is not a good idea 60# Having different flavours at the same time is not a good idea
57 for i in "" "-community" "-slotted" ; do 61for i in "" "-community" ; do
58 [[ "${i}" == ${PN#mysql} ]] || 62 [[ "${i}" == ${PN#mysql} ]] ||
59 DEPEND="${DEPEND} !dev-db/mysql${i}" 63 DEPEND="${DEPEND} !dev-db/mysql${i}"
60 done 64done
61 65
62 mysql_version_is_at_least "5.1" \ 66mysql_version_is_at_least "5.1" \
63 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 67|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
64 68
69mysql_version_is_at_least "5.1.12" \
70&& DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
71
65 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL 72# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
66 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 73PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
67 74
68 if mysql_version_is_at_least "5.1.12" ; then
69 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
70 fi
71
72 # Shorten the path because the socket path length must be shorter than 107 chars
73 # and we will run a mysql server during test phase
74 S="${WORKDIR}/mysql"
75
76 # BitKeeper dependency, compile-time only 75# BitKeeper dependency, compile-time only
77 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client" 76[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
78 77
78# Work out the default SERVER_URI correctly
79if [ -z "${SERVER_URI}" ]; then
80 # The community build is on the mirrors
81 if [ "${PN}" == "mysql-community" ]; then
82 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
83 # The enterprise source is on the primary site only
79 if [[ ${PN} == "mysql-slotted" ]] ; then 84 elif [ "${PN}" == "mysql" ]; then
80 DEPEND="${DEPEND} app-admin/eselect-mysql" 85 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
86 fi
81 fi 87fi
82 88
83 if [[ ${PN} == "mysql-slotted" ]] ; then
84 SLOT=""
85 tpv=( ${PV//[-._]/ } )
86 for vatom in 0 1 2 ; do
87 SLOT="${SLOT}${tpv[${vatom}]}_"
88 done
89 #finally SLOT=5_0_24
90 SLOT=${SLOT:0:${#SLOT}-1}
91 else
92 SLOT="0"
93 fi
94
95 # Define correct SRC_URIs 89# Define correct SRC_URIs
96 SRC_URI=" 90SRC_URI="${SERVER_URI}"
97 ${SERVER_URI} 91
92[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
93 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
98 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 94 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
99 "
100 mysql_version_is_at_least "5.1.12" \ 95mysql_version_is_at_least "5.1.12" \
101 && [[ -n "${PBXT_VERSION}" ]] \ 96&& [[ -n "${PBXT_VERSION}" ]] \
102 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 97&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
103 98
104 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 99DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
105 HOMEPAGE="http://www.mysql.com/" 100HOMEPAGE="http://www.mysql.com/"
106 LICENSE="GPL-2" 101LICENSE="GPL-2"
102SLOT="0"
107 IUSE="big-tables debug embedded minimal perl selinux ssl static" 103IUSE="big-tables debug embedded minimal perl selinux ssl static"
108 RESTRICT="confcache"
109 104
110 mysql_version_is_at_least "4.1" \ 105mysql_version_is_at_least "4.1" \
111 && IUSE="${IUSE} latin1" 106&& IUSE="${IUSE} latin1"
112 107
113 mysql_version_is_at_least "4.1.3" \ 108mysql_version_is_at_least "4.1.3" \
114 && IUSE="${IUSE} cluster extraengine" 109&& IUSE="${IUSE} cluster extraengine"
115 110
116 mysql_version_is_at_least "5.0" \ 111mysql_version_is_at_least "5.0" \
117 || IUSE="${IUSE} raid" 112|| IUSE="${IUSE} raid"
118 113
119 mysql_version_is_at_least "5.0.18" \ 114mysql_version_is_at_least "5.0.18" \
120 && IUSE="${IUSE} max-idx-128" 115&& IUSE="${IUSE} max-idx-128"
121 116
122 mysql_version_is_at_least "5.1" \ 117mysql_version_is_at_least "5.1" \
123 && IUSE="${IUSE} innodb" 118&& IUSE="${IUSE} innodb"
124 119
125 mysql_version_is_at_least "5.1" \ 120mysql_version_is_at_least "5.1" \
126 || IUSE="${IUSE} berkdb" 121|| IUSE="${IUSE} berkdb"
127 122
128 mysql_version_is_at_least "5.1.12" \ 123mysql_version_is_at_least "5.1.12" \
129 && IUSE="${IUSE} pbxt" 124&& IUSE="${IUSE} pbxt"
130 125
131 RDEPEND="${DEPEND} 126RDEPEND="${DEPEND}
132 sys-apps/mysql 127 !minimal? ( dev-db/mysql-init-scripts )
133 selinux? ( sec-policy/selinux-mysql ) 128 selinux? ( sec-policy/selinux-mysql )"
134 "
135
136fi # if [[ "${_MYPVR}" != "${PVR}" ]]
137 129
138EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 130EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
139 pkg_postinst pkg_config pkg_postrm 131 pkg_postinst pkg_config pkg_postrm
140 132
141# 133#
142# HELPER FUNCTIONS: 134# HELPER FUNCTIONS:
143# 135#
144 136
145bitkeeper_fetch() { 137bitkeeper_fetch() {
146
147 local reposuf 138 local reposuf
148 if [[ -z "${1}" ]] ; then 139 if [[ -z "${1}" ]] ; then
149 local tpv 140 local tpv
150 tpv=( ${PV//[-._]/ } ) 141 tpv=( ${PV//[-._]/ } )
151 reposuf="mysql-${tpv[0]}.${tpv[1]}" 142 reposuf="mysql-${tpv[0]}.${tpv[1]}"
152 else 143 else
153 reposuf="${1}" 144 reposuf="${1}"
154 fi 145 fi
155 einfo "using \"${reposuf}\" repository." 146 einfo "Using '${reposuf}' repository."
156 local repo_uri="bk://mysql.bkbits.net/${reposuf}" 147 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
157 ## -- ebk_store_dir: bitkeeper sources store directory 148 ## -- ebk_store_dir: bitkeeper sources store directory
158 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src" 149 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
159 ## -- ebk_fetch_cmd: bitkeeper fetch command 150 ## -- ebk_fetch_cmd: bitkeeper fetch command
160 # always fetch the latest revision, use -r<revision> if a specified revision is wanted 151 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
161 # hint: does not work 152 # hint: does not work
162 local ebk_fetch_cmd="sfioball" 153 local ebk_fetch_cmd="sfioball"
163 ## -- ebk_update_cmd: bitkeeper update command 154 ## -- ebk_update_cmd: bitkeeper update command
164 local ebk_update_cmd="update" 155 local ebk_update_cmd="update"
165 156
166 #addread "/etc/bitkeeper" 157 # addread "/etc/bitkeeper"
167 addwrite "${ebk_store_dir}" 158 addwrite "${ebk_store_dir}"
168 159
169 if [[ ! -d "${ebk_store_dir}" ]]; then 160 if [[ ! -d "${ebk_store_dir}" ]] ; then
170 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory" 161 debug-print "${FUNCNAME}: initial checkout, creating bitkeeper directory ..."
171 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}." 162 mkdir -p "${ebk_store_dir}" || die "BK: couldn't mkdir ${ebk_store_dir}"
172 fi 163 fi
173 164
174 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}" 165 pushd "${ebk_store_dir}" || die "BK: couldn't chdir to ${ebk_store_dir}"
175 166
176 local wc_path=${reposuf} 167 local wc_path=${reposuf}
177 168
178 if [[ ! -d "${wc_path}" ]]; then 169 if [[ ! -d "${wc_path}" ]] ; then
179 local options="-r+" 170 local options="-r+"
171
180 # first check out 172 # first checkout
181 einfo "bitkeeper check out start -->" 173 einfo "bitkeeper checkout start -->"
182 einfo " repository: ${repo_uri}" 174 einfo " repository: ${repo_uri}"
175
183 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \ 176 ${ebk_fetch_cmd} ${options} "${repo_uri}" "${wc_path}" \
184 || die "${EBK}: can't fetch from ${repo_uri}." 177 || die "BK: couldn't fetch from ${repo_uri}"
185 else 178 else
186 if [[ ! -d "${wc_path}/BK" ]]; then 179 if [[ ! -d "${wc_path}/BK" ]] ; then
187 popd 180 popd
188 die "Look like ${wc_path} is not a bitkeeper path." 181 die "Looks like ${wc_path} is not a bitkeeper path"
189 fi 182 fi
190 183
191 # update working copy 184 # update working copy
192 einfo "bitkeeper update start -->" 185 einfo "bitkeeper update start -->"
193 einfo " repository: ${repo_uri}" 186 einfo " repository: ${repo_uri}"
194 187
195 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \ 188 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
196 || die "BK: can't update from ${repo_uri} to ${wc_path}." 189 || die "BK: couldn't update from ${repo_uri} to ${wc_path}"
197 fi 190 fi
198 191
199 einfo " working copy: ${wc_path}" 192 einfo " working copy: ${wc_path}"
200 cd "${wc_path}" 193 cd "${wc_path}"
201 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}." 194 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: couldn't export to ${S}"
202 195
203 echo 196 echo
204 popd 197 popd
205
206} 198}
207 199
208mysql_disable_test() { 200mysql_disable_test() {
209 local testname="${1}" ; shift 201 local testname="${1}" ; shift
210 local reason="${@}" 202 local reason="${@}"
211 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 203 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
212 echo ${testname} : ${reason} >> "${mysql_disable_file}" 204 echo ${testname} : ${reason} >> "${mysql_disable_file}"
213 ewarn "test \"${testname}\" disabled because: \"${reason}\"" 205 ewarn "test '${testname}' disabled: '${reason}'"
214} 206}
215 207
216# void mysql_init_vars() 208# void mysql_init_vars()
217# 209#
218# Initialize global variables 210# Initialize global variables
219# 2005-11-19 <vivo@gentoo.org> 211# 2005-11-19 <vivo@gentoo.org>
220 212
221mysql_init_vars() { 213mysql_init_vars() {
222 if [[ ${SLOT} == "0" ]] ; then
223 MY_SUFFIX=""
224 else
225 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
226 fi
227 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 214 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
228 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 215 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
229 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 216 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
230 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 217 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
231 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 218 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
232 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 219 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
233 220
234 if [[ -z "${DATADIR}" ]] ; then 221 if [[ -z "${MY_DATADIR}" ]] ; then
235 DATADIR="" 222 MY_DATADIR=""
236 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 223 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
237 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \ 224 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
238 | sed -ne '/datadir/s|^--datadir=||p' \ 225 | sed -ne '/datadir/s|^--datadir=||p' \
239 | tail -n1` 226 | tail -n1`
240 if [[ -z "${DATADIR}" ]] ; then 227 if [[ -z "${MY_DATADIR}" ]] ; then
241 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 228 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
242 | sed -e 's/.*=\s*//'` 229 | sed -e 's/.*=\s*//' \
230 | tail -n1`
243 fi 231 fi
244 fi 232 fi
245 if [[ -z "${DATADIR}" ]] ; then 233 if [[ -z "${MY_DATADIR}" ]] ; then
246 DATADIR="${MY_LOCALSTATEDIR}" 234 MY_DATADIR="${MY_LOCALSTATEDIR}"
247 einfo "Using default DATADIR" 235 einfo "Using default MY_DATADIR"
248 fi 236 fi
249 elog "MySQL DATADIR is ${DATADIR}" 237 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
250 238
251 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 239 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
252 if [[ -e "${DATADIR}" ]] ; then 240 if [[ -e "${MY_DATADIR}" ]] ; then
253 elog "Previous datadir found, it's YOUR job to change" 241 elog "Previous datadir found, it's YOUR job to change"
254 elog "ownership and take care of it" 242 elog "ownership and take care of it"
255 PREVIOUS_DATADIR="yes" 243 PREVIOUS_DATADIR="yes"
256 else 244 else
257 PREVIOUS_DATADIR="no" 245 PREVIOUS_DATADIR="no"
261 fi 249 fi
262 250
263 MY_SOURCEDIR=${SERVER_URI##*/} 251 MY_SOURCEDIR=${SERVER_URI##*/}
264 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 252 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
265 253
266 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 254 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
267 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 255 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
268 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR 256 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
269} 257}
270 258
271configure_minimal() { 259configure_minimal() {
272 # These are things we exclude from a minimal build, please 260 # These are things we exclude from a minimal build, please
273 # note that the server actually does get built and installed, 261 # note that the server actually does get built and installed,
274 # but we then delete it before packaging. 262 # but we then delete it before packaging.
275 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 263 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
276 264
277 for i in ${minimal_exclude_list} ; do 265 for i in ${minimal_exclude_list} ; do
278 myconf="${myconf} --without-${i}" 266 myconf="${myconf} --without-${i}"
279 done 267 done
280 myconf="${myconf} --with-extra-charsets=none" 268 myconf="${myconf} --with-extra-charsets=none"
281 myconf="${myconf} --enable-local-infile" 269 myconf="${myconf} --enable-local-infile"
282 270
283 if useq "static" ; then 271 if use static ; then
284 myconf="${myconf} --with-client-ldflags=-all-static" 272 myconf="${myconf} --with-client-ldflags=-all-static"
285 myconf="${myconf} --disable-shared" 273 myconf="${myconf} --disable-shared --with-pic"
286 else 274 else
287 myconf="${myconf} --enable-shared --enable-static" 275 myconf="${myconf} --enable-shared --enable-static"
288 fi 276 fi
289 277
290 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 278 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
291 myconf="${myconf} --with-charset=utf8" 279 myconf="${myconf} --with-charset=utf8"
292 myconf="${myconf} --with-collation=utf8_general_ci" 280 myconf="${myconf} --with-collation=utf8_general_ci"
293 else 281 else
294 myconf="${myconf} --with-charset=latin1" 282 myconf="${myconf} --with-charset=latin1"
295 myconf="${myconf} --with-collation=latin1_swedish_ci" 283 myconf="${myconf} --with-collation=latin1_swedish_ci"
303 myconf="${myconf} --with-mysqld-user=mysql" 291 myconf="${myconf} --with-mysqld-user=mysql"
304 myconf="${myconf} --with-server" 292 myconf="${myconf} --with-server"
305 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock" 293 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
306 myconf="${myconf} --without-libwrap" 294 myconf="${myconf} --without-libwrap"
307 295
308 if useq "static" ; then 296 if use static ; then
309 myconf="${myconf} --with-mysqld-ldflags=-all-static" 297 myconf="${myconf} --with-mysqld-ldflags=-all-static"
310 myconf="${myconf} --with-client-ldflags=-all-static" 298 myconf="${myconf} --with-client-ldflags=-all-static"
311 myconf="${myconf} --disable-shared" 299 myconf="${myconf} --disable-shared --with-pic"
312 else 300 else
313 myconf="${myconf} --enable-shared --enable-static" 301 myconf="${myconf} --enable-shared --enable-static"
314 fi 302 fi
315 303
316 if useq "debug" ; then 304 if use debug ; then
317 myconf="${myconf} --with-debug=full" 305 myconf="${myconf} --with-debug=full"
318 else 306 else
319 myconf="${myconf} --without-debug" 307 myconf="${myconf} --without-debug"
320 mysql_version_is_at_least "4.1.3" \ 308 mysql_version_is_at_least "4.1.3" \
321 && useq "cluster" \ 309 && use cluster \
322 && myconf="${myconf} --without-ndb-debug" 310 && myconf="${myconf} --without-ndb-debug"
323 fi 311 fi
324 312
325 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then 313 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
326 myconf="${myconf} --with-charset=utf8" 314 myconf="${myconf} --with-charset=utf8"
327 myconf="${myconf} --with-collation=utf8_general_ci" 315 myconf="${myconf} --with-collation=utf8_general_ci"
328 else 316 else
329 myconf="${myconf} --with-charset=latin1" 317 myconf="${myconf} --with-charset=latin1"
330 myconf="${myconf} --with-collation=latin1_swedish_ci" 318 myconf="${myconf} --with-collation=latin1_swedish_ci"
331 fi 319 fi
332 320
333 if useq "embedded" ; then 321 if use embedded ; then
334 myconf="${myconf} --with-embedded-privilege-control" 322 myconf="${myconf} --with-embedded-privilege-control"
335 myconf="${myconf} --with-embedded-server" 323 myconf="${myconf} --with-embedded-server"
336 else 324 else
337 myconf="${myconf} --without-embedded-privilege-control" 325 myconf="${myconf} --without-embedded-privilege-control"
338 myconf="${myconf} --without-embedded-server" 326 myconf="${myconf} --without-embedded-server"
346 myconf="${myconf} --with-extra-tools" 334 myconf="${myconf} --with-extra-tools"
347 myconf="${myconf} --with-innodb" 335 myconf="${myconf} --with-innodb"
348 myconf="${myconf} --without-readline" 336 myconf="${myconf} --without-readline"
349 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 337 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
350 338
351 if useq "ssl" ; then
352 # --with-vio is not needed anymore, it's on by default and 339 # --with-vio is not needed anymore, it's on by default and
353 # has been removed from configure 340 # has been removed from configure
341 if use ssl ; then
354 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 342 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
343 fi
344
355 if mysql_version_is_at_least "5.0.6" ; then 345 if mysql_version_is_at_least "5.1.11" ; then
356 # myconf="${myconf} --with-yassl"
357 myconf="${myconf} --with-ssl" 346 myconf="${myconf} $(use_with ssl)"
347 else
348 myconf="${myconf} $(use_with ssl openssl)"
349 fi
350
351 if use berkdb ; then
352 # The following fix is due to a bug with bdb on SPARC's. See:
353 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
354 # It comes down to non-64-bit safety problems.
355 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
356 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
357 myconf="${myconf} --without-berkeley-db"
358 else 358 else
359 myconf="${myconf} --with-openssl" 359 myconf="${myconf} --with-berkeley-db=./bdb"
360 fi
361 else
362 myconf="${myconf} --without-openssl"
363 fi 360 fi
364 361 else
365 # The following fix is due to a bug with bdb on SPARC's. See:
366 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
367 # It comes down to non-64-bit safety problems.
368 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
369 elog "Berkeley DB support was disabled due to incompatible arch"
370 myconf="${myconf} --without-berkeley-db" 362 myconf="${myconf} --without-berkeley-db"
371 else
372 if useq "berkdb" ; then
373 myconf="${myconf} --with-berkeley-db=./bdb"
374 else
375 myconf="${myconf} --without-berkeley-db"
376 fi
377 fi 363 fi
378 364
379 if mysql_version_is_at_least "4.1.3" ; then 365 if mysql_version_is_at_least "4.1.3" ; then
380 myconf="${myconf} --with-geometry" 366 myconf="${myconf} --with-geometry"
381 myconf="${myconf} $(use_with cluster ndbcluster)" 367 myconf="${myconf} $(use_with cluster ndbcluster)"
382 fi 368 fi
383 369
384 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then 370 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
385 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 371 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
386 myconf="${myconf} --with-archive-storage-engine" 372 myconf="${myconf} --with-archive-storage-engine"
387 373
388 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 374 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
389 myconf="${myconf} --with-csv-storage-engine" 375 myconf="${myconf} --with-csv-storage-engine"
400 myconf="${myconf} --with-federated-storage-engine" 386 myconf="${myconf} --with-federated-storage-engine"
401 fi 387 fi
402 fi 388 fi
403 389
404 mysql_version_is_at_least "5.0.18" \ 390 mysql_version_is_at_least "5.0.18" \
405 && useq "max-idx-128" \ 391 && use max-idx-128 \
406 && myconf="${myconf} --with-max-indexes=128" 392 && myconf="${myconf} --with-max-indexes=128"
407} 393}
408 394
409configure_51() { 395configure_51() {
410 # TODO: !!!! readd --without-readline 396 # TODO: !!!! readd --without-readline
415 myconf="${myconf} --with-geometry" 401 myconf="${myconf} --with-geometry"
416 myconf="${myconf} --with-readline" 402 myconf="${myconf} --with-readline"
417 myconf="${myconf} --with-row-based-replication" 403 myconf="${myconf} --with-row-based-replication"
418 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 404 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
419 myconf="${myconf} --without-pstack" 405 myconf="${myconf} --without-pstack"
420 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 406 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
421 407
422 # 5.1 introduces a new way to manage storage engines (plugins) 408 # 5.1 introduces a new way to manage storage engines (plugins)
423 # like configuration=none 409 # like configuration=none
424 local plugins="csv,myisam,myisammrg,heap" 410 local plugins="csv,myisam,myisammrg,heap"
425 if useq "extraengine" ; then 411 if use extraengine ; then
426 # like configuration=max-no-ndb, archive and example removed in 5.1.11 412 # like configuration=max-no-ndb, archive and example removed in 5.1.11
427 plugins="${plugins},archive,blackhole,example,federated,partition" 413 plugins="${plugins},archive,blackhole,example,federated,partition"
428 414
429 elog "Before using the Federated storage engine, please be sure to read" 415 elog "Before using the Federated storage engine, please be sure to read"
430 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 416 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
431 fi 417 fi
432 418
433 if useq "innodb" ; then 419 if use innodb ; then
434 plugins="${plugins},innobase" 420 plugins="${plugins},innobase"
435 fi 421 fi
436 422
437 # like configuration=max-no-ndb 423 # like configuration=max-no-ndb
438 if useq "cluster" ; then 424 if use cluster ; then
439 plugins="${plugins},ndbcluster" 425 plugins="${plugins},ndbcluster"
440 myconf="${myconf} --with-ndb-binlog" 426 myconf="${myconf} --with-ndb-binlog"
441 fi 427 fi
442 428
443 if mysql_version_is_at_least "5.2" ; then 429 if mysql_version_is_at_least "5.2" ; then
453 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 439 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
454 440
455 einfo "Reconfiguring dir '${PWD}'" 441 einfo "Reconfiguring dir '${PWD}'"
456 AT_GNUCONF_UPDATE="yes" eautoreconf 442 AT_GNUCONF_UPDATE="yes" eautoreconf
457 443
458 local myconf 444 local myconf=""
459 myconf="${myconf} --with-mysql=${S}"
460 mkdir -p ${T}/lib
461 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}" 445 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
462 useq "debug" && myconf="${myconf} --with-debug=full" 446 use debug && myconf="${myconf} --with-debug=full"
463 # TODO is safe/needed to use econf here ? 447 # TODO: is it safe/needed to use econf here ?
464 ./configure ${myconf} || die "problem configuring pbxt storage engine" 448 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
465 # TODO is safe/needed to use emake here ? 449 # TODO: is it safe/needed to use emake here ?
466 make || die "problem making pbxt storage engine (${myconf})" 450 make || die "Problem making PBXT storage engine (${myconf})"
467 451
468 popd 452 popd
469 # TODO: modify test suite 453 # TODO: modify test suite for PBXT
470} 454}
471 455
472pbxt_src_install() { 456pbxt_src_install() {
473 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 457 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
474 make install || die "failed pbxt install" 458 make install || die "Failed to install PBXT"
475 popd 459 popd
476} 460}
477 461
478# 462#
479# EBUILD FUNCTIONS 463# EBUILD FUNCTIONS
480# 464#
481
482mysql_pkg_setup() { 465mysql_pkg_setup() {
483 enewgroup mysql 60 || die "problem adding 'mysql' group" 466 if hasq test ${FEATURES} ; then
484 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 467 if ! use minimal ; then
468 if ! hasq userpriv ${FEATURES} ; then
469 die "Testing with FEATURES=-userpriv is no longer supported by upstream"
470 fi
471 fi
472 fi
485 473
486 # Check for USE flag problems in pkg_setup 474 # Check for USE flag problems in pkg_setup
487 if useq "static" && useq "ssl" ; then 475 if use static && use ssl ; then
488 eerror "MySQL does not support being built statically with SSL support enabled!" 476 eerror "MySQL does not support being built statically with SSL support enabled!"
489 die "MySQL does not support being built statically with SSL support enabled!" 477 die "MySQL does not support being built statically with SSL support enabled!"
490 fi 478 fi
491 479
492 if ! mysql_version_is_at_least "5.0" \ 480 if ! mysql_version_is_at_least "5.0" \
493 && useq "raid" \ 481 && use raid \
494 && useq "static" ; then 482 && use static ; then
495 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 483 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
496 eerror "with RAID support enabled." 484 eerror "with RAID support enabled."
497 die "USE flags 'raid' and 'static' conflict!" 485 die "USE flags 'raid' and 'static' conflict!"
498 fi 486 fi
499 487
500 if mysql_version_is_at_least "4.1.3" \ 488 if mysql_version_is_at_least "4.1.3" \
501 && ( useq "cluster" || useq "extraengine" ) \ 489 && ( use cluster || use extraengine ) \
502 && useq "minimal" ; then 490 && use minimal ; then
503 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 491 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
504 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 492 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
505 fi 493 fi
494
495 # This should come after all of the die statements
496 enewgroup mysql 60 || die "problem adding 'mysql' group"
497 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
506 498
507 mysql_check_version_range "4.0 to 5.0.99.99" \ 499 mysql_check_version_range "4.0 to 5.0.99.99" \
508 && useq "berkdb" \ 500 && use berkdb \
509 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 501 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
510} 502}
511 503
512mysql_src_unpack() { 504mysql_src_unpack() {
513 # Initialize the proper variables first 505 # Initialize the proper variables first
514 mysql_init_vars 506 mysql_init_vars
515 507
516 unpack ${A} 508 unpack ${A}
509 # Grab the patches
510 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
511 # Bitkeeper checkout support
517 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 512 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
518 if mysql_check_version_range "5.1 to 5.1.99" ; then 513 if mysql_check_version_range "5.1 to 5.1.99" ; then
519 bitkeeper_fetch "mysql-5.1-ndb" 514 bitkeeper_fetch "mysql-5.1-ndb"
520 elif mysql_check_version_range "5.2.0 to 5.2.99" ; then 515 elif mysql_check_version_range "5.2 to 5.2.99" ; then
521 bitkeeper_fetch "mysql-5.2-falcon" 516 bitkeeper_fetch "mysql-5.2-falcon"
522 else 517 else
523 bitkeeper_fetch 518 bitkeeper_fetch
524 fi 519 fi
525 cd "${S}" 520 cd "${S}"
526 einfo "running upstream autorun on bk sources" 521 einfo "Running upstream autorun over BK sources ..."
527 BUILD/autorun.sh 522 BUILD/autorun.sh
528 else 523 else
529 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 524 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
530 cd "${S}" 525 cd "${S}"
531 fi 526 fi
532 527
533 # Apply the patches for this MySQL version 528 # Apply the patches for this MySQL version
534 EPATCH_SUFFIX="patch" 529 EPATCH_SUFFIX="patch"
535 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 530 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
531 # Clean out old items
532 rm -f "${EPATCH_SOURCE}"/*
533 # Now link in right patches
536 mysql_mv_patches 534 mysql_mv_patches
537 epatch || die "failed to apply all patches" 535 # And apply
536 epatch
538 537
539 # Additional checks, remove bundled zlib 538 # Additional checks, remove bundled zlib
540 rm -f "${S}/zlib/"*.[ch] 539 rm -f "${S}/zlib/"*.[ch]
541 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 540 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
542 rm -f "scripts/mysqlbug" 541 rm -f "scripts/mysqlbug"
557 556
558 local rebuilddirlist d 557 local rebuilddirlist d
559 558
560 if mysql_version_is_at_least "5.1.12" ; then 559 if mysql_version_is_at_least "5.1.12" ; then
561 rebuilddirlist="." 560 rebuilddirlist="."
562 # TODO IMPO! Check this with a cmake expert 561 # TODO: check this with a cmake expert
563 useq "innodb" \ 562 use innodb \
564 && cmake \ 563 && cmake \
565 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \ 564 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
566 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \ 565 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
567 "storage/innobase" 566 "storage/innobase"
568 else 567 else
569 rebuilddirlist=". innobase" 568 rebuilddirlist=". innobase"
570 fi 569 fi
571 570
575 AT_GNUCONF_UPDATE="yes" eautoreconf 574 AT_GNUCONF_UPDATE="yes" eautoreconf
576 popd &>/dev/null 575 popd &>/dev/null
577 done 576 done
578 577
579 if mysql_check_version_range "4.1 to 5.0.99.99" \ 578 if mysql_check_version_range "4.1 to 5.0.99.99" \
580 && useq "berkdb" ; then 579 && use berkdb ; then
581 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 580 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
581 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
582 || die "Could not copy libtool.m4 to bdb/dist/"
582 pushd "bdb/dist" \ 583 pushd "bdb/dist" &>/dev/null
583 && sh s_all \ 584 sh s_all \
584 || die "Failed bdb reconfigure" \ 585 || die "Failed bdb reconfigure"
585 &>/dev/null
586 popd &>/dev/null 586 popd &>/dev/null
587 fi 587 fi
588} 588}
589 589
590mysql_src_compile() { 590mysql_src_compile() {
592 mysql_init_vars 592 mysql_init_vars
593 593
594 # $myconf is modified by the configure_* functions 594 # $myconf is modified by the configure_* functions
595 local myconf="" 595 local myconf=""
596 596
597 if useq "minimal" ; then 597 if use minimal ; then
598 configure_minimal 598 configure_minimal
599 else 599 else
600 configure_common 600 configure_common
601 if mysql_version_is_at_least "5.1.10" ; then 601 if mysql_version_is_at_least "5.1.10" ; then
602 configure_51 602 configure_51
616 mysql_version_is_at_least "5.0" \ 616 mysql_version_is_at_least "5.0" \
617 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 617 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
618 export CXXFLAGS 618 export CXXFLAGS
619 619
620 econf \ 620 econf \
621 --program-suffix="${MY_SUFFIX}" \
622 --libexecdir="/usr/sbin" \ 621 --libexecdir="/usr/sbin" \
623 --sysconfdir="${MY_SYSCONFDIR}" \ 622 --sysconfdir="${MY_SYSCONFDIR}" \
624 --localstatedir="${MY_LOCALSTATEDIR}" \ 623 --localstatedir="${MY_LOCALSTATEDIR}" \
625 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 624 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
626 --libdir="${MY_LIBDIR}" \ 625 --libdir="${MY_LIBDIR}" \
637 | xargs -0 -n100 sed -i \ 636 | xargs -0 -n100 sed -i \
638 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 637 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
639 638
640 emake || die "emake failed" 639 emake || die "emake failed"
641 640
642 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile 641 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
643} 642}
644 643
645mysql_src_install() { 644mysql_src_install() {
646 # Make sure the vars are correctly initialized 645 # Make sure the vars are correctly initialized
647 mysql_init_vars 646 mysql_init_vars
648 647
649 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 648 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
650 649
651 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install 650 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
652 651
653 insinto "${MY_INCLUDEDIR}" 652 insinto "${MY_INCLUDEDIR}"
654 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 653 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
655 654
656 # Convenience links 655 # Convenience links
657 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 656 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
658 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 657 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
659 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 658 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
660 659
661 # Various junk (my-*.cnf moved elsewhere) 660 # Various junk (my-*.cnf moved elsewhere)
662 rm -Rf "${D}/usr/share/info" 661 rm -Rf "${D}/usr/share/info"
663 for removeme in "mysql-log-rotate" mysql.server* \ 662 for removeme in "mysql-log-rotate" mysql.server* \
664 binary-configure* my-*.cnf mi_test_all* 663 binary-configure* my-*.cnf mi_test_all*
665 do 664 do
666 rm -f "${D}"/usr/share/mysql/${removeme} 665 rm -f "${D}"/usr/share/mysql/${removeme}
667 done 666 done
668 667
669 # TODO change at Makefile-am level
670 if [[ ${PN} == "mysql-slotted" ]] ; then
671 for moveme in "mysql_fix_privilege_tables.sql" \
672 "fill_help_tables.sql" "ndb-config-2-node.ini"
673 do
674 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
675 done
676 fi
677
678 # clean up stuff for a minimal build 668 # Clean up stuff for a minimal build
679 if useq "minimal" ; then 669 if use minimal ; then
680 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 670 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
681 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 671 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
682 rm -f "${D}/usr/sbin/mysqld" 672 rm -f "${D}/usr/sbin/mysqld"
683 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 673 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
684 fi 674 fi
685 675
686 if [[ ${PN} == "mysql-slotted" ]] ; then
687 local notcatched=$(ls "${D}/usr/share/mysql"/*)
688 if [[ -n "${notcatched}" ]] ; then
689 ewarn "QA notice"
690 ewarn "${notcatched} files in /usr/share/mysql"
691 ewarn "bug mysql-herd to manage them"
692 fi
693 rm -Rf "${D}/usr/share/mysql"
694 fi
695
696 # Configuration stuff 676 # Configuration stuff
697 if mysql_version_is_at_least "4.1" ; then 677 if mysql_version_is_at_least "4.1" ; then
698 mysql_mycnf_version="4.1" 678 mysql_mycnf_version="4.1"
699 else 679 else
700 mysql_mycnf_version="4.0" 680 mysql_mycnf_version="4.0"
701 fi 681 fi
702 insinto "${MY_SYSCONFDIR}" 682 insinto "${MY_SYSCONFDIR}"
703 doins scripts/mysqlaccess.conf 683 doins scripts/mysqlaccess.conf
704 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
705 -e "s!@DATADIR@!${DATADIR}!g" \ 684 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
706 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 685 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
707 > "${TMPDIR}/my.cnf.ok" 686 > "${TMPDIR}/my.cnf.ok"
708 if mysql_version_is_at_least "4.1" && useq "latin1" ; then 687 if mysql_version_is_at_least "4.1" && use latin1 ; then
709 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 688 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
710 fi 689 fi
711 newins "${TMPDIR}/my.cnf.ok" my.cnf 690 newins "${TMPDIR}/my.cnf.ok" my.cnf
712 691
713 # Minimal builds don't have the MySQL server 692 # Minimal builds don't have the MySQL server
714 if ! useq "minimal" ; then 693 if ! use minimal ; then
715 # Empty directories ... 694 # Empty directories ...
716 diropts "-m0750" 695 diropts "-m0750"
717 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 696 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
718 dodir "${DATADIR}" 697 dodir "${MY_DATADIR}"
719 keepdir "${DATADIR}" 698 keepdir "${MY_DATADIR}"
720 chown -R mysql:mysql "${D}/${DATADIR}" 699 chown -R mysql:mysql "${D}/${MY_DATADIR}"
721 fi 700 fi
722 701
723 diropts "-m0755" 702 diropts "-m0755"
724 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 703 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
725 dodir "${folder}" 704 dodir "${folder}"
728 done 707 done
729 fi 708 fi
730 709
731 # Docs 710 # Docs
732 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 711 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
712 doinfo ${S}/Docs/mysql.info
733 713
734 # Minimal builds don't have the MySQL server 714 # Minimal builds don't have the MySQL server
735 if ! useq "minimal" ; then 715 if ! use minimal ; then
736 docinto "support-files" 716 docinto "support-files"
737 for script in \ 717 for script in \
738 support-files/my-*.cnf \ 718 support-files/my-*.cnf \
739 support-files/magic \ 719 support-files/magic \
740 support-files/ndb-config-2-node.ini 720 support-files/ndb-config-2-node.ini
744 724
745 docinto "scripts" 725 docinto "scripts"
746 for script in scripts/mysql* ; do 726 for script in scripts/mysql* ; do
747 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 727 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
748 done 728 done
749 fi
750 729
751 if [[ ${PN} == "mysql-slotted" ]] ; then
752 # MOVED HERE DUE TO BUG #121445
753 # create a list of files, to be used
754 # by external utilities
755 mkdir -p "${D}/var/lib/eselect/mysql/"
756 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
757 pushd "${D}/" &>/dev/null
758 find usr/bin/ usr/sbin/ \
759 -type f -name "*${MY_SUFFIX}*" \
760 -and -not -name "mysql_config${MY_SUFFIX}" \
761 > "${filelist}"
762 find usr/share/man \
763 -type f -name "*${MY_SUFFIX}*" \
764 | sed -e 's/$/.gz/' \
765 >> "${filelist}"
766 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
767 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
768 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
769 popd &>/dev/null
770 fi 730 fi
771 731
772 mysql_lib_symlinks "${D}" 732 mysql_lib_symlinks "${D}"
773} 733}
774 734
780mysql_pkg_postinst() { 740mysql_pkg_postinst() {
781 # Make sure the vars are correctly initialized 741 # Make sure the vars are correctly initialized
782 mysql_init_vars 742 mysql_init_vars
783 743
784 # Check FEATURES="collision-protect" before removing this 744 # Check FEATURES="collision-protect" before removing this
785 [[ -d "${ROOT}/var/log/mysql" ]] \
786 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}" 745 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
787 746
788 # Secure the logfiles 747 # Secure the logfiles
789 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 748 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
790 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 749 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
791 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 750 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
792 751
793 # Minimal builds don't have the MySQL server 752 # Minimal builds don't have the MySQL server
794 if ! useq "minimal" ; then 753 if ! use minimal ; then
795 docinto "support-files" 754 docinto "support-files"
796 for script in \ 755 for script in \
797 support-files/my-*.cnf \ 756 support-files/my-*.cnf \
798 support-files/magic \ 757 support-files/magic \
799 support-files/ndb-config-2-node.ini 758 support-files/ndb-config-2-node.ini
803 762
804 docinto "scripts" 763 docinto "scripts"
805 for script in scripts/mysql* ; do 764 for script in scripts/mysql* ; do
806 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 765 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
807 done 766 done
808 fi
809 767
810 einfo "you may want to read slotting upgrade documents in the overlay" 768 einfo
811 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then 769 elog "You might want to run:"
812 # TODO tell it better ;-) 770 elog "\"emerge --config =${CATEGORY}/${PF}\""
771 elog "if this is a new install."
772 einfo
773 fi
774
775 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
776 # TODO: explain it better
813 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 777 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
814 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 778 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
815 einfo "if, after that you cannot start the mysql server" 779 elog "if, after that, you cannot start the MySQL server,"
816 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 780 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
817 einfo "use the mysql upgrade script to restore the table" 781 elog "use the MySQL upgrade script to restore the table"
818 einfo " or " 782 elog "or execute the following SQL command:"
819 einfo "CREATE TABLE IF NOT EXISTS plugin (" 783 elog " CREATE TABLE IF NOT EXISTS plugin ("
820 einfo " name char(64) binary DEFAULT '' NOT NULL," 784 elog " name char(64) binary DEFAULT '' NOT NULL,"
821 einfo " dl char(128) DEFAULT '' NOT NULL," 785 elog " dl char(128) DEFAULT '' NOT NULL,"
822 einfo " PRIMARY KEY (name)" 786 elog " PRIMARY KEY (name)"
823 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;" 787 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
824 fi 788 fi
789
825 mysql_check_version_range "4.0 to 5.0.99.99" \ 790 mysql_check_version_range "4.0 to 5.0.99.99" \
826 && useq "berkdb" \ 791 && use berkdb \
827 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 792 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
828} 793}
829 794
830mysql_pkg_config() { 795mysql_pkg_config() {
831 # Make sure the vars are correctly initialized 796 # Make sure the vars are correctly initialized
832 mysql_init_vars 797 mysql_init_vars
833 798
834 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 799 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
835 800
836 if built_with_use ${CATEGORY}/${PN} minimal ; then 801 if built_with_use ${CATEGORY}/${PN} minimal ; then
837 die "Minimal builds do NOT include the MySQL server" 802 die "Minimal builds do NOT include the MySQL server"
838 fi 803 fi
839 804
840 local pwd1="a" 805 local pwd1="a"
841 local pwd2="b" 806 local pwd2="b"
842 local maxtry=5 807 local maxtry=5
843 808
844 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 809 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
845 ewarn "You have already a MySQL database in place." 810 ewarn "You have already a MySQL database in place."
846 ewarn "(${ROOT}/${DATADIR}/*)" 811 ewarn "(${ROOT}/${MY_DATADIR}/*)"
847 ewarn "Please rename or delete it if you wish to replace it." 812 ewarn "Please rename or delete it if you wish to replace it."
848 die "MySQL database already exists!" 813 die "MySQL database already exists!"
849 fi 814 fi
850 815
851 einfo "Creating the mysql database and setting proper" 816 einfo "Creating the mysql database and setting proper"
870 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 835 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
871 || touch "${TMPDIR}/fill_help_tables.sql" 836 || touch "${TMPDIR}/fill_help_tables.sql"
872 help_tables="${TMPDIR}/fill_help_tables.sql" 837 help_tables="${TMPDIR}/fill_help_tables.sql"
873 838
874 pushd "${TMPDIR}" &>/dev/null 839 pushd "${TMPDIR}" &>/dev/null
875 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 840 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
841 if [ $? -ne 0 ]; then
842 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
843 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
844 fi
876 popd &>/dev/null 845 popd &>/dev/null
877 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 846 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
878 || die "MySQL databases not installed" 847 || die "MySQL databases not installed"
879 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 848 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2> /dev/null
880 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 849 chmod 0750 "${ROOT}/${MY_DATADIR}" 2> /dev/null
881 850
882 if mysql_version_is_at_least "4.1.3" ; then 851 if mysql_version_is_at_least "4.1.3" ; then
883 options="--skip-ndbcluster" 852 options="--skip-ndbcluster"
884 853
885 # Filling timezones, see 854 # Filling timezones, see
896 local mysqld="${ROOT}/usr/sbin/mysqld \ 865 local mysqld="${ROOT}/usr/sbin/mysqld \
897 ${options} \ 866 ${options} \
898 --user=mysql \ 867 --user=mysql \
899 --skip-grant-tables \ 868 --skip-grant-tables \
900 --basedir=${ROOT}/usr \ 869 --basedir=${ROOT}/usr \
901 --datadir=${ROOT}/${DATADIR} \ 870 --datadir=${ROOT}/${MY_DATADIR} \
902 --skip-innodb \ 871 --skip-innodb \
903 --skip-bdb \ 872 --skip-bdb \
904 --skip-networking \ 873 --skip-networking \
905 --max_allowed_packet=8M \ 874 --max_allowed_packet=8M \
906 --net_buffer_length=16K \ 875 --net_buffer_length=16K \
936 wait %1 905 wait %1
937 einfo "Done" 906 einfo "Done"
938} 907}
939 908
940mysql_pkg_postrm() { 909mysql_pkg_postrm() {
941 if [[ ${PN} == "mysql-slotted" ]] ; then
942 mysql_lib_symlinks 910 : # mysql_lib_symlinks "${D}"
943 mysql_clients_link_to_best_version
944 fi
945} 911}

Legend:
Removed from v.1.58  
changed lines
  Added in v.1.89

  ViewVC Help
Powered by ViewVC 1.1.20